/*
  aes.h - AES Library for NXP_JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111_1307  USA
*/
#pragma once

#include <string.h>
#include <jendefs.h>
#include <AHI_AES.h>

#define WORD_ALIGN __attribute__((aligned(4)))

class AES
{
  public:

    typedef enum
    {
      AESMODE_CCM_0   = 0,
      AESMODE_CCM_8   = 2,
      AESMODE_CCM_16  = 4,
      AESMODE_CCM_32  = 8,
      AESMODE_CCM_64  = 16,
      AESMODE_CCM_128 = 32,
    } AESMODE;

    static void begin(AESMODE mode, uint8 *pu8KeyData, uint8 u8KeyLen);
    static bool encryption(uint8 *pau8Data, uint8 u8DataLen, uint32 u32Nonce = 0, uint8 *pu8AuthData = 0, uint8 u8AuthLen = 0, uint8 *pau8Chksum = 0);
    static bool decryption(uint8 *pau8Data, uint8 u8DataLen, uint32 u32Nonce = 0, uint8 *pu8AuthData = 0, uint8 u8AuthLen = 0, uint8 *pau8Chksum = 0);
    static AESMODE mode(void);

  private:

    static AESMODE     _mode;
    static tuAES_Block _nonce;
};
