/*
  brownout.cpp - BrownOut Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#include "brownout.h"

void BrownOut::configure(VBOREF vboref, bool reset, bool svm, bool falling, bool rising)
{
  vAHI_BrownOutConfigure(vboref, reset, svm, falling, rising);
}

bool BrownOut::status(void)
{
  return bAHI_BrownOutStatus();
}

bool BrownOut::hasResetEvent(void)
{
  return bAHI_BrownOutEventResetStatus();
}

BrownOut::STATUS BrownOut::polling(void)
{
  return (STATUS)u32AHI_BrownOutPoll();
}
