/*
  brownout.h - BrownOut Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <jendefs.h>
#include <AppHardwareApi.h>

class BrownOut
{
  public:

    typedef enum
    {
      VBOREF_1V95 = E_AHI_VBOREF_1V95, // 1.95V
      VBOREF_2V0  = E_AHI_VBOREF_2V0,  // 2.0V (default)
      VBOREF_2V1  = E_AHI_VBOREF_2V1,  // 2.1V
      VBOREF_2V2  = E_AHI_VBOREF_2V2,  // 2.2V
      VBOREF_2V3  = E_AHI_VBOREF_2V3,  // 2.3V
      VBOREF_2V4  = E_AHI_VBOREF_2V4,  // 2.4V
      VBOREF_2V7  = E_AHI_VBOREF_2V7,  // 2.7V
      VBOREF_3V0  = E_AHI_VBOREF_3V0,  // 3.0V
    } VBOREF;

    static void configure(VBOREF vboref, bool reset, bool svm, bool falling, bool rising);
    static bool status(void);
    static bool hasResetEvent(void);

    typedef enum
    {
      STATUS_FEM = E_AHI_SYSCTRL_VFEM_MASK,
      STATUS_REM = E_AHI_SYSCTRL_VREM_MASK,
    } STATUS;

    static STATUS polling(void);
};
