/*
  clock.cpp - Clock Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#include "clock.h"

bool Clock::external32K(EXT32KSRC clksrc)
{
  return bAHI_Set32KhzClockMode(clksrc);
}

void Clock::external32KXtal(void)
{
  vAHI_Init32KhzXtal();
}

void Clock::external32KRC(EXT32KRC trim)
{
  vAHI_Trim32KhzRC(trim);
}

void Clock::source(CLKSRC clksrc, bool powerdown)
{
  return vAHI_SelectClockSource(clksrc, powerdown);
}

Clock::CLKSRC Clock::source(void)
{
  return (CLKSRC)bAHI_GetClkSource();
}

bool Clock::rate(CLKDIV clkdiv)
{
  return bAHI_SetClockRate(clkdiv);
}

Clock::CLKDIV Clock::rate(void)
{
  return (CLKDIV)u8AHI_GetSystemClkRate();
}

bool Clock::external32MXtal(void)
{
  return bAHI_Clock32MHzStable();
}

void Clock::xtalPull(XTALPULL mode)
{
  vAHI_ClockXtalPull(mode);
}

void Clock::fastStartUp(bool automatic, bool powerdown)
{
  vAHI_EnableFastStartUp(automatic, powerdown);
}

bool Clock::internal32MRC(void)
{
  return bAHI_TrimHighSpeedRCOsc();
}

void Clock::optimizeWaitStates(void)
{
  return vAHI_OptimiseWaitStates();
}
