/*
  device.h - Device includes for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <jendefs.h>
#include <AppHardwareApi.h>
#include <MicroSpecific.h>
#include "clock.h"
#include "sysctrl.h"
#include "rndgen.h"
#include "pulscounter.h"
#include "watchdog.h"
#include "ticktimer.h"
#include "waketimer.h"
#include "timer.h"
#include "flash.h"
#include "eeprom.h"
#include "gpio.h"
#include "analog.h"
#include "adc.h"
#include "comparator.h"
#include "infrared.h"
#include "uart.h"
#include "spi.h"
#include "wire.h"
#include "wpan.h"
#include "alarm.h"
#include "debug.h"
#include "task.h"
#include "system.h"
#include "muldiv.h"
#include "jn516x.h"
#include "led.h"
#include "aes.h"
#include "fifo.h"

/* Board Library Include */
#ifndef BOARD_NAME
#define BOARD_NAME none
#endif

#define  STRINGIFY(str)   #str
#define  EXPANDSTR(x)     STRINGIFY(x)
//#define  EXPAND1(x) x
//#define  EXPAND2(x, y)    EXPAND1(x)y
//#define  EXPAND3(x, y, z) EXPAND2(x, y)z
#undef   INCLUDE_NAME
#define  INCLUDE_NAME     EXPANDSTR(EXPAND3(board_,BOARD_NAME,.h))
#include<board_shutter.h>

