/*
  muldiv.h - Multiplication and Division Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <jendefs.h>

class MulDiv
{
  public:

    static int32 cmp64(int64 a, int64 b) __attribute__((optimize(1)));
    static int32 cmpu64(uint64 a, uint64 b) __attribute__((optimize(1)));
    static int64 add64(int64 a, int64 b) __attribute__((optimize(1)));
    static int64 sub64(int64 a, int64 b) __attribute__((optimize(1)));
    static int64 shl64(int64 a, uint32 b) __attribute__((optimize(1)));
    static int64 shr64(int64 a, uint32 b) __attribute__((optimize(1)));
    static int64 sar64(int64 a, uint32 b) __attribute__((optimize(1)));
    static uint64 mulu32u32(uint32 a, uint32 b) __attribute__((noinline,optimize(1)));
    static uint64 divu64u64(uint64 a, uint64 b, uint64 *r = 0) __attribute__((noinline,optimize(3)));
};
