/*
  rndgen.h - Random Number Generator Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <jendefs.h>
#include <AppHardwareApi.h>

class RNDGen
{
  public:

    typedef enum
    {
      RND_SINGLE_SHOT = E_AHI_RND_SINGLE_SHOT, // single-shot mode
      RND_CONTINUOUS  = E_AHI_RND_CONTINUOUS,  // continuous mode
    } RND;

    static void start(RND mode = RND_SINGLE_SHOT, PR_HWINT_APPCALLBACK prRndCallback = 0);
    static void stop(void);
    static int read(void);
    static bool available(void);
};
