/*
  sysctrl.h - System Control Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <jendefs.h>
#include <AppHardwareApi.h>

class SysCtrl
{
  public:

    typedef enum
    {
      INTSRC_DIO0  = 0,
      INTSRC_DIO1  = 1,
      INTSRC_DIO2  = 2,
      INTSRC_DIO3  = 3,
      INTSRC_DIO4  = 4,
      INTSRC_DIO5  = 5,
      INTSRC_DIO6  = 6,
      INTSRC_DIO7  = 7,
      INTSRC_DIO8  = 8,
      INTSRC_DIO9  = 9,
      INTSRC_DIO10 = 10,
      INTSRC_DIO11 = 11,
      INTSRC_DIO12 = 12,
      INTSRC_DIO13 = 13,
      INTSRC_DIO14 = 14,
      INTSRC_DIO15 = 15,
      INTSRC_DIO16 = 16,
      INTSRC_DIO17 = 17,
      INTSRC_DIO18 = 18,
      INTSRC_DIO19 = 19,
      INTSRC_PC0   = E_AHI_SYSCTRL_PC0,
      INTSRC_PC1   = E_AHI_SYSCTRL_PC1,
      INTSRC_VFEM  = E_AHI_SYSCTRL_VFES,
      INTSRC_VREM  = E_AHI_SYSCTRL_VRES,
      INTSRC_WK0   = E_AHI_SYSCTRL_WK0,
      INTSRC_WK1   = E_AHI_SYSCTRL_WK1,
      INTSRC_COMP0 = E_AHI_SYSCTRL_COMP0,
      INTSRC_FEC   = E_AHI_SYSCTRL_FEC,
      INTSRC_RNDEM = E_AHI_SYSCTRL_RNDES,
      INTSRC_CKEM  = E_AHI_SYSCTRL_CKES,
    } INTSRC;

    static void begin(void);
    static void interrupt(INTSRC intsrc, PR_HWINT_APPCALLBACK prSysCtrlCallback);
    static void clearInterruptStatus(INTSRC intsrc);

  private:

    static void SysCtrlCallback(uint32 u32Device, uint32 u32ItemBitmap);

    static PR_HWINT_APPCALLBACK _callbacks[32];
};
