/*
  waketimer.h - Wake Timer Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <jendefs.h>
#include <AppHardwareApi.h>

class WakeTimer
{
  public:

    typedef enum
    {
      WAKE_0 = 0,
      WAKE_1 = 1,
    } WAKE;

    static void begin(void);
    static void start(WAKE wake, uint32 seconds, PR_HWINT_APPCALLBACK ptWkCallback = 0);
    static void stop(WAKE wake);
    static uint64 read(WAKE wake);
    static uint8 status(void);
    static bool status(WAKE wake);
    static uint8 firedStatus(void);
    static bool firedStatus(WAKE wake);
    static uint32 calibrate(void);

  private:

    static uint32 _calibrate;
};
