/*
  watchdog.cpp - Watchdog Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#include "watchdog.h"

void Watchdog::begin(void)
{
#ifndef WATCHDOG_ENABLED
  stop();
#endif
}

void Watchdog::reset(void)
{
#ifdef WATCHDOG_ENABLED
  restart();
#endif
}

void Watchdog::start(WDTO timeout)
{
  vAHI_WatchdogStart(timeout);
}

void Watchdog::stop(void)
{
  vAHI_WatchdogStop();
}

void Watchdog::restart(void)
{
  vAHI_WatchdogRestart();
}

bool Watchdog::resetEvent(void)
{
  return bAHI_WatchdogResetEvent();
}

uint16 Watchdog::readValue(void)
{
  return u16AHI_WatchdogReadValue();
}

void Watchdog::exception(bool bEnable)
{
  vAHI_WatchdogException(bEnable);
}
