/*
  watchdog.h - Watchdog Library for NXP-JN516x

  Copyright (c) 2022 Sasapea's Lab. All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
*/
#pragma once

#include <jendefs.h>
#include <AppHardwareApi.h>

class Watchdog
{
  public:

    typedef enum
    {
      WDTO_8MS     = 1,
      WDTO_24MS    = 2,
      WDTO_40MS    = 3,
      WDTO_72MS    = 4,
      WDTO_136MS   = 5,
      WDTO_264MS   = 6,
      WDTO_520MS   = 7,
      WDTO_1032MS  = 8,
      WDTO_2056MS  = 9,
      WDTO_4104MS  = 10,
      WDTO_8200MS  = 11,
      WDTO_16392MS = 12,
    } WDTO;

    static void begin(void);
    static void reset(void);
    static void start(WDTO timeout);
    static void stop(void);
    static void restart(void);
    static bool resetEvent(void);
    static uint16 readValue(void);
    static void exception(bool bEnable);
};
